/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
 * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
 */

/*
 * DisplayMenuItem.cpp
 *
 *  Created on: Dec 14, 2009
 *      Author: crueger
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/MemDebug.hpp"

#include <sstream>
#include <cmath>

#include "Menu/TextMenu/DisplayMenuItem.hpp"
#include "Views/StringView.hpp"


DisplayMenuItem::DisplayMenuItem(TxMenu* const _menu, StringView *_view):
  MenuItem('\0',"",_menu),
  view(_view),
  title("")
{
}

DisplayMenuItem::DisplayMenuItem(TxMenu* const _menu, StringView *_view, const std::string &_title, char _spacer, int _length ):
  MenuItem('\0',"",_menu),
  view(_view),
  title(_title),
  length(_length),
  spacer(_spacer)
{
}

DisplayMenuItem::~DisplayMenuItem()
{}


void DisplayMenuItem::doTrigger(){}
bool DisplayMenuItem::checkTrigger(char c){
  return false;
}

const std::string DisplayMenuItem::formatEntry(){
  std::stringstream s;
  if(title.length()>0) {
    int pre = floor((length-title.length())/2.0);
    int post = ceil((length-title.length())/2.0);
    for(int i=0;i<pre;i++)
      s << spacer;
    s << title;
    for(int i=0;i<post;i++)
          s << spacer;
    s << "\n";
  }
  s << view->toString();
  return s.str();
}


const std::string DisplayMenuItem::getDescription(){
  return std::string("");
}
